/*
 * Decompresses some PeX 0.99 files as well as all known public versions of Continuum.
 * Written by Snrrrub (snrrrub@yahoo.com): April 16, 2004
 * Original DeX code (c) by Chafe 2000
 */

#ifndef DECOMPRESS_H
#define DECOMPRESS_H

#if defined(__cplusplus)
extern "C" {
#endif

struct VersionInfo
{
	unsigned int index;
	char versionName[128];
	unsigned int checksum;
	void * DecryptAlgo;
	void * EncryptData;
	void * UnpackedSize;
	void * Sections;
	void * EntryPoint;
	void * DecompAlgo;
	void * ImportTable;
	void * ImportKey;
	void * ImportROL;
	void * SizeFunction;
	void * FixSectionFunction;
};

extern void * m_inputFile;
extern void * m_outputFile;
extern void * m_decryptedData;		// decompressed data
extern void * PEOffset;
extern void * SectTable;
extern void * PEXSection;
extern VersionInfo * Version;
extern long m_outputFileSize;

void * getPEOffset(void * mzFile, long fileSize);
void * getSectionTable(void * peFile);
long   getEntryPointRVA(void * peFile);
void * findSectionEntryWithRVA(void * sectionTable, long address);
long   getPhysicalOffset(void * sectionEntry);
long   generateChecksum(void * pexSection);
VersionInfo * findVersion(long checksum);
void   unpack();

void FreeAllStuff();

#if defined(__cplusplus)
}
#endif

#endif